package at.ac.uibk.gitsearch.domain;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

import javax.persistence.*;
import javax.validation.constraints.*;

import org.springframework.data.elasticsearch.annotations.FieldType;
import java.io.Serializable;

/**
 * A WatchListEntry.
 */
@Entity
@Table(name = "watch_list_entry")
@Cache(usage = CacheConcurrencyStrategy.READ_WRITE)
@org.springframework.data.elasticsearch.annotations.Document(indexName = "watchlistentry")
public class WatchListEntry implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Column(name = "exercise_id", nullable = false)
    private String exerciseId;

    @Column(name = "exercise_name")
    private String exerciseName;

    @ManyToOne(optional = false)
    @NotNull
    @JsonIgnoreProperties(value = "watchListEntries", allowSetters = true)
    private UserWatchList watchlistId;

    // jhipster-needle-entity-add-field - JHipster will add fields here
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getExerciseId() {
        return exerciseId;
    }

    public WatchListEntry exerciseId(String exerciseId) {
        this.exerciseId = exerciseId;
        return this;
    }

    public void setExerciseId(String exerciseId) {
        this.exerciseId = exerciseId;
    }

    public String getExerciseName() {
        return exerciseName;
    }

    public WatchListEntry exerciseName(String exerciseName) {
        this.exerciseName = exerciseName;
        return this;
    }

    public void setExerciseName(String exerciseName) {
        this.exerciseName = exerciseName;
    }

    public UserWatchList getWatchlistId() {
        return watchlistId;
    }

    public WatchListEntry watchlistId(UserWatchList userWatchList) {
        this.watchlistId = userWatchList;
        return this;
    }

    public void setWatchlistId(UserWatchList userWatchList) {
        this.watchlistId = userWatchList;
    }
    // jhipster-needle-entity-add-getters-setters - JHipster will add getters and setters here

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof WatchListEntry)) {
            return false;
        }
        return id != null && id.equals(((WatchListEntry) o).id);
    }

    @Override
    public int hashCode() {
        return 31;
    }

    // prettier-ignore
    @Override
    public String toString() {
        return "WatchListEntry{" +
            "id=" + getId() +
            ", exerciseId='" + getExerciseId() + "'" +
            ", exerciseName='" + getExerciseName() + "'" +
            "}";
    }
}
